prereq.sh 18 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703
  1. #!/bin/sh
  2. # This file is part of the OpenADK project. OpenADK is copyrighted
  3. # material, please see the LICENCE file in the top-level directory.
  4. # resolve prerequisites for OpenADK build
  5. topdir=$(pwd)
  6. target="$@"
  7. flags="$MAKEFLAGS"
  8. out=0
  9. mirror=http://distfiles.openadk.org
  10. makever=4.1
  11. bashver=4.3.30
  12. dlverbose=0
  13. # detect operating system
  14. os=$(env uname)
  15. osver=$(env uname -r)
  16. printf " ---> $os $osver for build detected.\n"
  17. # check if the filesystem is case sensitive
  18. rm -f foo
  19. echo >FOO
  20. if [ -e foo ]; then
  21. printf "ERROR: OpenADK cannot be built in a case-insensitive file system."
  22. case $os in
  23. CYG*)
  24. printf "Building OpenADK on $os needs a small registry change."
  25. printf "http://cygwin.com/cygwin-ug-net/using-specialnames.html"
  26. ;;
  27. Darwin*)
  28. printf "Building OpenADK on $os needs a case-sensitive disk partition."
  29. printf "For Snow Leopard and above you can use diskutil to resize your existing disk."
  30. printf "Example: sudo diskutil resizeVolume disk0s2 90G 1 jhfsx adk 30G"
  31. printf "For older versions you might consider to use a disk image:"
  32. printf "hdiutil create -type SPARSE -fs 'Case-sensitive Journaled HFS+' -size 30g ~/openadk.dmg"
  33. ;;
  34. esac
  35. rm -f FOO
  36. exit 1
  37. fi
  38. rm -f FOO
  39. if [ "$target" = "v" ]; then
  40. dlverbose=1
  41. fi
  42. # do we have a download tool?
  43. tools="curl wget"
  44. for tool in $tools; do
  45. printf " ---> checking if $tool is installed.. "
  46. if which $tool >/dev/null; then
  47. printf "found\n"
  48. case $tool in
  49. curl)
  50. if [ $dlverbose -eq 1 ]; then
  51. FETCHCMD="$(which $tool) -L -k -f -\# -o "
  52. else
  53. FETCHCMD="$(which $tool) -L -k -f -s -o "
  54. fi
  55. ;;
  56. wget)
  57. if [ $dlverbose -eq 1 ]; then
  58. FETCHCMD="$(which $tool) --no-check-certificate -O "
  59. else
  60. FETCHCMD="$(which $tool) --no-check-certificate -q -O "
  61. fi
  62. ;;
  63. esac
  64. break
  65. else
  66. printf "not found\n"
  67. continue
  68. fi
  69. done
  70. if [ -z "$FETCHCMD" ]; then
  71. printf "ERROR: no download tool found. Fatal error.\n"
  72. exit 1
  73. fi
  74. # do we have a checksum tool?
  75. tools="sha256sum sha256 cksum shasum"
  76. for tool in $tools; do
  77. printf " ---> checking if $tool is installed.. "
  78. if which $tool >/dev/null 2>/dev/null; then
  79. printf "found\n"
  80. # check if cksum is usable
  81. case $tool in
  82. sha256sum)
  83. SHA256=$(which $tool)
  84. ;;
  85. sha256)
  86. SHA256="$(which $tool) -q"
  87. ;;
  88. cksum)
  89. if cksum -q >/dev/null 2>/dev/null; then
  90. SHA256="$(which $tool) -q -a sha256"
  91. else
  92. continue
  93. fi
  94. ;;
  95. shasum)
  96. SHA256="$(which $tool) -a 256"
  97. ;;
  98. esac
  99. break
  100. else
  101. printf "not found\n"
  102. continue
  103. fi
  104. done
  105. if [ -z "$SHA256" ]; then
  106. printf "ERROR: no checksum tool found. Fatal error.\n"
  107. exit 1
  108. fi
  109. # create download dir
  110. if [ ! -d $topdir/dl ]; then
  111. mkdir -p $topdir/dl
  112. fi
  113. # check for c compiler
  114. compilerbins="clang cc gcc"
  115. for compilerbin in $compilerbins; do
  116. printf " ---> checking if $compilerbin is installed.. "
  117. if which $compilerbin >/dev/null; then
  118. printf "found\n"
  119. CC=$compilerbin
  120. CCFOUND=1
  121. break
  122. else
  123. printf "not found\n"
  124. continue
  125. fi
  126. done
  127. if [ -z "$CCFOUND" ]; then
  128. printf "ERROR: no C compiler found. Fatal error.\n"
  129. exit 1
  130. fi
  131. # check for c++ compiler
  132. compilerbins="clang++ c++ g++"
  133. for compilerbin in $compilerbins; do
  134. printf " ---> checking if $compilerbin is installed.. "
  135. if which $compilerbin >/dev/null; then
  136. printf "found\n"
  137. CXX=$compilerbin
  138. CXXFOUND=1
  139. break
  140. else
  141. printf "not found\n"
  142. continue
  143. fi
  144. done
  145. if [ -z "$CXXFOUND" ]; then
  146. printf "ERROR: no C++ compiler found. Fatal error.\n"
  147. exit 1
  148. fi
  149. gnu_host_name=$(${CC} -dumpmachine)
  150. # relocation of topdir?
  151. olddir=$(grep "^ADK_TOPDIR" prereq.mk 2>/dev/null |cut -d '=' -f 2)
  152. newdir=$(pwd)
  153. if [ ! -z "$olddir" ]; then
  154. if [ "$olddir" != "$newdir" ]; then
  155. printf " ---> adk directory was relocated, fixing .."
  156. sed -i -e "s#$olddir#$newdir#g" $(find target_* -name \*.pc|xargs) 2>/dev/null
  157. sed -i -e "s#$olddir#$newdir#g" $(find host_${gnu_host_name} -type f|xargs) 2>/dev/null
  158. sed -i -e "s#$olddir#$newdir#g" $(find target_*/scripts -type f|xargs) 2>/dev/null
  159. sed -i -e "s#$olddir#$newdir#" target_*/etc/ipkg.conf 2>/dev/null
  160. sleep 2
  161. printf "done\n"
  162. fi
  163. fi
  164. case :$PATH: in
  165. (*:$topdir/host_${gnu_host_name}/bin:*) ;;
  166. (*) export PATH=$topdir/host_${gnu_host_name}/bin:$PATH ;;
  167. esac
  168. # check for GNU make
  169. makebins="gmake make"
  170. for makebin in $makebins; do
  171. printf " ---> checking if $makebin is installed.. "
  172. if which $makebin >/dev/null 2>/dev/null; then
  173. printf "found\n"
  174. printf " ---> checking if it is GNU make.. "
  175. $makebin --version 2>/dev/null| grep GNU >/dev/null
  176. if [ $? -eq 0 ]; then
  177. printf "yes\n"
  178. MAKE=$(which $makebin)
  179. break
  180. else
  181. # we need to build GNU make
  182. printf "no\n"
  183. printf " ---> compiling missing GNU make.. "
  184. cd dl
  185. $FETCHCMD make-${makever}.tar.gz $mirror/make-${makever}.tar.gz
  186. if [ $? -ne 0 ]; then
  187. printf "ERROR: failed to download make from $mirror\n"
  188. exit 1
  189. fi
  190. cd ..
  191. mkdir tmp
  192. cd tmp
  193. tar xzf ../dl/make-${makever}.tar.gz
  194. cd make-$makever
  195. ./configure --prefix=$topdir/host_$gnu_host_name/
  196. make
  197. make install
  198. cd ..
  199. cd ..
  200. rm -rf tmp
  201. MAKE=$topdir/host_$gnu_host_name/bin/make
  202. makebin=$topdir/host_$gnu_host_name/bin/make
  203. printf " done\n"
  204. fi
  205. else
  206. printf "not found\n"
  207. continue
  208. fi
  209. done
  210. # check for bash
  211. printf " ---> checking if bash is installed.. "
  212. if which bash >/dev/null; then
  213. printf "found\n"
  214. printf " ---> checking if it is bash 4.x.. "
  215. bash --version 2>/dev/null| grep -i "Version 4" >/dev/null
  216. if [ $? -eq 0 ]; then
  217. printf "yes\n"
  218. else
  219. # we need to build GNU bash 4.x
  220. printf "not found\n"
  221. printf " ---> compiling missing GNU bash.. "
  222. cd dl
  223. $FETCHCMD bash-${bashver}.tar.gz $mirror/bash-${bashver}.tar.gz
  224. if [ $? -ne 0 ]; then
  225. printf "ERROR: failed to download make from $mirror\n"
  226. exit 1
  227. fi
  228. cd ..
  229. mkdir tmp
  230. cd tmp
  231. tar xzf ../dl/bash-${bashver}.tar.gz
  232. cd bash-${bashver}
  233. ./configure --prefix=$topdir/host_$gnu_host_name/
  234. make
  235. make install
  236. cd ..
  237. cd ..
  238. rm -rf tmp
  239. printf " done\n"
  240. fi
  241. fi
  242. # skip the script if distclean / cleandir
  243. if [ "$target" = "distclean" -o "$target" = "cleandir" ]; then
  244. touch prereq.mk
  245. $makebin ADK_TOPDIR=$topdir -s -f Makefile.adk $flags $target
  246. exit 0
  247. fi
  248. printf " ---> checking if strings is installed.. "
  249. if ! which strings >/dev/null 2>&1; then
  250. echo You must install strings to continue.
  251. echo
  252. out=1
  253. printf "not found\n"
  254. fi
  255. printf "found\n"
  256. printf " ---> checking if perl is installed.. "
  257. if ! which perl >/dev/null 2>&1; then
  258. echo You must install perl to continue.
  259. echo
  260. out=1
  261. printf "not found\n"
  262. fi
  263. printf "found\n"
  264. # creating prereq.mk
  265. echo "ADK_TOPDIR:=$(readlink -nf . 2>/dev/null || pwd -P)" > $topdir/prereq.mk
  266. echo "BASH:=$(which bash)" >> $topdir/prereq.mk
  267. echo "SHELL:=$(which bash)" >> $topdir/prereq.mk
  268. echo "GMAKE:=$MAKE" >> $topdir/prereq.mk
  269. echo "MAKE:=$MAKE" >> $topdir/prereq.mk
  270. echo "FETCHCMD:=$FETCHCMD" >> $topdir/prereq.mk
  271. echo "SHA256:=$SHA256" >> $topdir/prereq.mk
  272. echo "GNU_HOST_NAME:=${gnu_host_name}" >> $topdir/prereq.mk
  273. echo "OS_FOR_BUILD:=${os}" >> $topdir/prereq.mk
  274. echo "ARCH_FOR_BUILD:=$(${CC} -dumpmachine | sed \
  275. -e 's/x86_64-linux-gnux32/x32/' \
  276. -e s'/-.*//' \
  277. -e 's/sparc.*/sparc/' \
  278. -e 's/armeb.*/armeb/g' \
  279. -e 's/arm.*/arm/g' \
  280. -e 's/m68k.*/m68k/' \
  281. -e 's/sh[234]/sh/' \
  282. -e 's/mips-.*/mips/' \
  283. -e 's/mipsel-.*/mipsel/' \
  284. -e 's/i[3-9]86/x86/' \
  285. )" >>prereq.mk
  286. if [ "$CC" = "clang" ]; then
  287. echo "HOST_CC:=${CC} -fbracket-depth=1024" >> $topdir/prereq.mk
  288. else
  289. echo "HOST_CC:=${CC}" >> $topdir/prereq.mk
  290. fi
  291. if [ "$CXX" = "clang++" ]; then
  292. echo "HOST_CXX:=${CXX} -fbracket-depth=1024" >> $topdir/prereq.mk
  293. else
  294. echo "HOST_CXX:=${CXX}" >> $topdir/prereq.mk
  295. fi
  296. echo "HOST_CFLAGS:=-O0 -g0" >> $topdir/prereq.mk
  297. echo "HOST_CXXFLAGS:=-O0 -g0" >> $topdir/prereq.mk
  298. echo 'LANGUAGE:=C' >> $topdir/prereq.mk
  299. echo 'LC_ALL:=C' >> $topdir/prereq.mk
  300. echo "_PATH:=$PATH" >> $topdir/prereq.mk
  301. echo "PATH:=${topdir}/scripts:/usr/sbin:$PATH" >> $topdir/prereq.mk
  302. echo "GIT:=$(which git 2>/dev/null)" >> $topdir/prereq.mk
  303. echo "export ADK_TOPDIR GIT SHA256 BASH SHELL" >> $topdir/prereq.mk
  304. # check if compiler works
  305. cat >Makefile.tmp <<'EOF'
  306. include ${ADK_TOPDIR}/prereq.mk
  307. all: test
  308. test: test.c
  309. @${HOST_CC} ${HOST_CFLAGS} -o $@ $^ ${LDADD}
  310. EOF
  311. cat >test.c <<-'EOF'
  312. #include <stdio.h>
  313. int
  314. main()
  315. {
  316. printf("YES");
  317. return (0);
  318. }
  319. EOF
  320. $MAKE --no-print-directory ADK_TOPDIR=$topdir -f Makefile.tmp 2>&1
  321. X=$(./test)
  322. if [ $X != YES ]; then
  323. echo "$X" | sed 's/^/| /'
  324. echo Cannot compile a simple test programme.
  325. echo You must install a host make and C compiler.
  326. echo
  327. out=1
  328. fi
  329. rm test.c test Makefile.tmp 2>/dev/null
  330. # error out on any required prerequisite
  331. if [ $out -ne 0 ]; then
  332. exit $out
  333. fi
  334. host_build_bc=0
  335. if which bc >/dev/null 2>&1; then
  336. if ! echo quit|bc -q 2>/dev/null >/dev/null; then
  337. host_build_bc=1
  338. else
  339. if bc -v 2>&1| grep -q BSD >/dev/null 2>&1; then
  340. host_build_bc=1
  341. fi
  342. fi
  343. else
  344. host_build_bc=1
  345. fi
  346. host_build_bison=0
  347. if ! which bison >/dev/null 2>&1; then
  348. host_build_bison=1
  349. fi
  350. host_build_bzip2=0
  351. if ! which bzip2 >/dev/null 2>&1; then
  352. host_build_bzip2=1
  353. fi
  354. host_build_file=0
  355. if ! which file >/dev/null 2>&1; then
  356. host_build_file=1
  357. fi
  358. host_build_flex=0
  359. if ! which flex >/dev/null 2>&1; then
  360. host_build_flex=1
  361. fi
  362. host_build_m4=0
  363. if ! which m4 >/dev/null 2>&1; then
  364. host_build_m4=1
  365. fi
  366. host_build_mksh=0
  367. if ! which mksh >/dev/null 2>&1; then
  368. host_build_mksh=1
  369. fi
  370. host_build_patch=0
  371. if ! which patch >/dev/null 2>&1; then
  372. host_build_patch=1
  373. fi
  374. host_build_pkgconf=0
  375. if ! which pkgconf >/dev/null 2>&1; then
  376. host_build_pkgconf=1
  377. fi
  378. host_build_tar=0
  379. if which tar >/dev/null 2>&1; then
  380. if ! tar --version 2>/dev/null|grep GNU >/dev/null;then
  381. host_build_tar=1
  382. fi
  383. else
  384. host_build_tar=1
  385. fi
  386. host_build_findutils=0
  387. if which xargs >/dev/null 2>&1; then
  388. if ! xargs --version 2>/dev/null|grep GNU >/dev/null;then
  389. host_build_findutils=1
  390. fi
  391. fi
  392. if which find >/dev/null 2>&1; then
  393. if ! find --version 2>/dev/null|grep GNU >/dev/null;then
  394. host_build_findutils=1
  395. fi
  396. fi
  397. host_build_grep=0
  398. if which grep >/dev/null 2>&1; then
  399. if ! grep --version 2>/dev/null|grep GNU >/dev/null;then
  400. host_build_grep=1
  401. fi
  402. fi
  403. host_build_gawk=0
  404. if ! which gawk >/dev/null 2>&1; then
  405. host_build_gawk=1
  406. fi
  407. host_build_sed=0
  408. if which sed >/dev/null 2>&1; then
  409. if ! sed --version 2>/dev/null|grep GNU >/dev/null;then
  410. host_build_sed=1
  411. fi
  412. fi
  413. host_build_xz=0
  414. if ! which xz >/dev/null 2>&1; then
  415. host_build_xz=1
  416. fi
  417. # optional
  418. host_build_cdrtools=0
  419. if ! which mkisofs >/dev/null 2>&1; then
  420. host_build_cdrtools=1
  421. fi
  422. host_build_ccache=0
  423. if ! which ccache >/dev/null 2>&1; then
  424. host_build_ccache=1
  425. fi
  426. host_build_genext2fs=0
  427. if ! which genext2fs >/dev/null 2>&1; then
  428. host_build_genext2fs=1
  429. fi
  430. host_build_lzma=0
  431. if ! which lzma >/dev/null 2>&1; then
  432. host_build_lzma=1
  433. fi
  434. host_build_lz4=0
  435. if ! which lz4c >/dev/null 2>&1; then
  436. host_build_lz4=1
  437. fi
  438. host_build_lzop=0
  439. if ! which lzop >/dev/null 2>&1; then
  440. host_build_lzop=1
  441. fi
  442. host_build_qemu=0
  443. if ! which qemu-img >/dev/null 2>&1; then
  444. host_build_qemu=1
  445. fi
  446. host_build_coreutils=0
  447. if which tr >/dev/null 2>&1; then
  448. if ! tr --version 2>/dev/null|grep GNU >/dev/null;then
  449. host_build_coreutils=1
  450. fi
  451. fi
  452. echo "config ADK_HOST_BUILD_TOOLS" > $topdir/target/config/Config.in.prereq
  453. printf "\t%s\n" "bool" >> $topdir/target/config/Config.in.prereq
  454. printf "\t%s\n" "default y" >> $topdir/target/config/Config.in.prereq
  455. # always required
  456. if [ $host_build_bc -eq 1 ]; then
  457. printf "\t%s\n" "select ADK_HOST_BUILD_BC" >> $topdir/target/config/Config.in.prereq
  458. fi
  459. if [ $host_build_bison -eq 1 ]; then
  460. printf "\t%s\n" "select ADK_HOST_BUILD_BISON" >> $topdir/target/config/Config.in.prereq
  461. fi
  462. if [ $host_build_bzip2 -eq 1 ]; then
  463. printf "\t%s\n" "select ADK_HOST_BUILD_BZIP2" >> $topdir/target/config/Config.in.prereq
  464. fi
  465. if [ $host_build_file -eq 1 ]; then
  466. printf "\t%s\n" "select ADK_HOST_BUILD_FILE" >> $topdir/target/config/Config.in.prereq
  467. fi
  468. if [ $host_build_flex -eq 1 ]; then
  469. printf "\t%s\n" "select ADK_HOST_BUILD_FLEX" >> $topdir/target/config/Config.in.prereq
  470. fi
  471. if [ $host_build_gawk -eq 1 ]; then
  472. printf "\t%s\n" "select ADK_HOST_BUILD_GAWK" >> $topdir/target/config/Config.in.prereq
  473. fi
  474. if [ $host_build_grep -eq 1 ]; then
  475. printf "\t%s\n" "select ADK_HOST_BUILD_GREP" >> $topdir/target/config/Config.in.prereq
  476. fi
  477. if [ $host_build_m4 -eq 1 ]; then
  478. printf "\t%s\n" "select ADK_HOST_BUILD_M4" >> $topdir/target/config/Config.in.prereq
  479. fi
  480. if [ $host_build_mksh -eq 1 ]; then
  481. printf "\t%s\n" "select ADK_HOST_BUILD_MKSH" >> $topdir/target/config/Config.in.prereq
  482. fi
  483. if [ $host_build_patch -eq 1 ]; then
  484. printf "\t%s\n" "select ADK_HOST_BUILD_PATCH" >> $topdir/target/config/Config.in.prereq
  485. fi
  486. if [ $host_build_pkgconf -eq 1 ]; then
  487. printf "\t%s\n" "select ADK_HOST_BUILD_PKGCONF" >> $topdir/target/config/Config.in.prereq
  488. fi
  489. if [ $host_build_findutils -eq 1 ]; then
  490. printf "\t%s\n" "select ADK_HOST_BUILD_FINDUTILS" >> $topdir/target/config/Config.in.prereq
  491. fi
  492. if [ $host_build_sed -eq 1 ]; then
  493. printf "\t%s\n" "select ADK_HOST_BUILD_SED" >> $topdir/target/config/Config.in.prereq
  494. fi
  495. if [ $host_build_tar -eq 1 ]; then
  496. printf "\t%s\n" "select ADK_HOST_BUILD_TAR" >> $topdir/target/config/Config.in.prereq
  497. fi
  498. if [ $host_build_xz -eq 1 ]; then
  499. printf "\t%s\n" "select ADK_HOST_BUILD_XZ" >> $topdir/target/config/Config.in.prereq
  500. fi
  501. # optional
  502. if [ $host_build_ccache -eq 1 ]; then
  503. printf "\t%s\n" "select ADK_HOST_BUILD_CCACHE if ADK_HOST_NEED_CCACHE" >> $topdir/target/config/Config.in.prereq
  504. fi
  505. if [ $host_build_cdrtools -eq 1 ]; then
  506. printf "\t%s\n" "select ADK_HOST_BUILD_CDRTOOLS if ADK_HOST_NEED_CDRTOOLS" >> $topdir/target/config/Config.in.prereq
  507. fi
  508. if [ $host_build_genext2fs -eq 1 ]; then
  509. printf "\t%s\n" "select ADK_HOST_BUILD_GENEXT2FS if ADK_HOST_NEED_GENEXT2FS" >> $topdir/target/config/Config.in.prereq
  510. fi
  511. if [ $host_build_lzma -eq 1 ]; then
  512. printf "\t%s\n" "select ADK_HOST_BUILD_LZMA if ADK_HOST_NEED_LZMA" >> $topdir/target/config/Config.in.prereq
  513. fi
  514. if [ $host_build_lz4 -eq 1 ]; then
  515. printf "\t%s\n" "select ADK_HOST_BUILD_LZ4 if ADK_HOST_NEED_LZ4" >> $topdir/target/config/Config.in.prereq
  516. fi
  517. if [ $host_build_lzop -eq 1 ]; then
  518. printf "\t%s\n" "select ADK_HOST_BUILD_LZOP if ADK_HOST_NEED_LZOP" >> $topdir/target/config/Config.in.prereq
  519. fi
  520. if [ $host_build_qemu -eq 1 ]; then
  521. printf "\t%s\n" "select ADK_HOST_BUILD_QEMU if ADK_HOST_NEED_QEMU" >> $topdir/target/config/Config.in.prereq
  522. fi
  523. if [ $host_build_coreutils -eq 1 ]; then
  524. printf "\t%s\n" "select ADK_HOST_BUILD_COREUTILS if ADK_HOST_NEED_COREUTILS" >> $topdir/target/config/Config.in.prereq
  525. fi
  526. # create Host OS symbols
  527. case $os in
  528. Linux)
  529. printf "\nconfig ADK_HOST_LINUX\n" >> $topdir/target/config/Config.in.prereq
  530. printf "\tbool\n" >> $topdir/target/config/Config.in.prereq
  531. printf "\tdefault y\n" >> $topdir/target/config/Config.in.prereq
  532. ;;
  533. Darwin)
  534. printf "\nconfig ADK_HOST_DARWIN\n" >> $topdir/target/config/Config.in.prereq
  535. printf "\tbool\n" >> $topdir/target/config/Config.in.prereq
  536. printf "\tdefault y\n" >> $topdir/target/config/Config.in.prereq
  537. ;;
  538. OpenBSD)
  539. printf "\nconfig ADK_HOST_OPENBSD\n" >> $topdir/target/config/Config.in.prereq
  540. printf "\tbool\n" >> $topdir/target/config/Config.in.prereq
  541. printf "\tdefault y\n" >> $topdir/target/config/Config.in.prereq
  542. ;;
  543. FreeBSD)
  544. printf "\nconfig ADK_HOST_FREEBSD\n" >> $topdir/target/config/Config.in.prereq
  545. printf "\tbool\n" >> $topdir/target/config/Config.in.prereq
  546. printf "\tdefault y\n" >> $topdir/target/config/Config.in.prereq
  547. ;;
  548. NetBSD)
  549. printf "\nconfig ADK_HOST_NETBSD\n" >> $topdir/target/config/Config.in.prereq
  550. printf "\tbool\n" >> $topdir/target/config/Config.in.prereq
  551. printf "\tdefault y\n" >> $topdir/target/config/Config.in.prereq
  552. ;;
  553. MirBSD)
  554. printf "\nconfig ADK_HOST_MIRBSD\n" >> $topdir/target/config/Config.in.prereq
  555. printf "\tbool\n" >> $topdir/target/config/Config.in.prereq
  556. printf "\tdefault y\n" >> $topdir/target/config/Config.in.prereq
  557. ;;
  558. Cygwin*)
  559. printf "\nconfig ADK_HOST_CYGWIN\n" >> $topdir/target/config/Config.in.prereq
  560. printf "\tbool\n" >> $topdir/target/config/Config.in.prereq
  561. printf "\tdefault y\n" >> $topdir/target/config/Config.in.prereq
  562. ;;
  563. esac
  564. if [ "$target" = "defconfig" ]; then
  565. $makebin ADK_TOPDIR=$topdir --no-print-directory -f Makefile.adk $flags $target
  566. exit 0
  567. fi
  568. if [ ! -f $topdir/.config ]; then
  569. # create a config if no exist
  570. touch .firstrun
  571. $makebin ADK_TOPDIR=$topdir --no-print-directory -f Makefile.adk menuconfig
  572. else
  573. # scan host-tool prerequisites of certain packages before building.
  574. . $topdir/.config
  575. if [ -n "$ADK_PACKAGE_KODI" ]; then
  576. NEED_JAVA="$NEED_JAVA kodi"
  577. fi
  578. if [ -n "$ADK_PACKAGE_ICU4C" ]; then
  579. NEED_STATIC_LIBSTDCXX="$NEED_STATIC_LIBSTDCXX icu4c"
  580. fi
  581. if [ -n "$ADK_PACKAGE_XKEYBOARD_CONFIG" ]; then
  582. NEED_XKBCOMP="$NEED_XKBCOMP xkeyboard-config"
  583. fi
  584. if [ -n "$ADK_PACKAGE_FONT_BITSTREAM_100DPI" ]; then
  585. NEED_MKFONTDIR="$NEED_MKFONTDIR font-bitstream-100dpi"
  586. fi
  587. if [ -n "$ADK_PACKAGE_FONT_BITSTREAM_75DPI" ]; then
  588. NEED_MKFONTDIR="$NEED_MKFONTDIR font-bitstream-75dpi"
  589. fi
  590. if [ -n "$ADK_PACKAGE_FONT_ADOBE_100DPI" ]; then
  591. NEED_MKFONTDIR="$NEED_MKFONTDIR font-adobe-100dpi"
  592. fi
  593. if [ -n "$ADK_PACKAGE_FONT_ADOBE_75DPI" ]; then
  594. NEED_MKFONTDIR="$NEED_MKFONTDIR font-adobe-75dpi"
  595. fi
  596. if [ -n "$NEED_MKFONTDIR" ]; then
  597. if ! which mkfontdir >/dev/null 2>&1; then
  598. printf "You need mkfontdir to build $NEED_MKFONTDIR"
  599. out=1
  600. fi
  601. fi
  602. if [ -n "$NEED_XKBCOMP" ]; then
  603. if ! which xkbcomp >/dev/null 2>&1; then
  604. printf "You need xkbcomp to build $NEED_XKBCOMP"
  605. out=1
  606. fi
  607. fi
  608. if [ -n "$NEED_JAVA" ]; then
  609. if ! which java >/dev/null 2>&1; then
  610. printf "You need java to build $NEED_JAVA"
  611. out=1
  612. fi
  613. fi
  614. if [ -n "$NEED_STATIC_LIBSTDCXX" ]; then
  615. cat >test.c <<-'EOF'
  616. #include <stdio.h>
  617. int
  618. main()
  619. {
  620. return (0);
  621. }
  622. EOF
  623. if ! $CXX -static-libstdc++ -o test test.c 2>/dev/null ; then
  624. printf "You need static version of libstdc++ installed to build $NEED_STATIC_LIBSTDCXX"
  625. out=1
  626. rm test test.c 2>/dev/null
  627. fi
  628. fi
  629. # error out
  630. if [ $out -ne 0 ]; then
  631. exit $out
  632. fi
  633. # start build
  634. $makebin ADK_TOPDIR=$topdir --no-print-directory -f Makefile.adk $flags $target
  635. fi